VERSION 5.00
Object = "{FE0065C0-1B7B-11CF-9D53-00AA003C9CB6}#1.1#0"; "COMCT232.OCX"
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   6495
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8505
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   433
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   567
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmPerspec 
      Caption         =   "Perspective depth"
      Height          =   795
      Left            =   240
      TabIndex        =   7
      Top             =   3540
      Width           =   1575
      Begin VB.TextBox txtPerspec 
         Height          =   285
         Left            =   255
         TabIndex        =   9
         Text            =   "Text1"
         Top             =   345
         Width           =   750
      End
      Begin ComCtl2.UpDown UpDown2 
         Height          =   420
         Left            =   1155
         TabIndex        =   8
         Top             =   240
         Width           =   195
         _ExtentX        =   344
         _ExtentY        =   741
         _Version        =   327681
         Value           =   150
         BuddyControl    =   "txtPerspec"
         BuddyDispid     =   196610
         OrigLeft        =   960
         OrigTop         =   300
         OrigRight       =   1155
         OrigBottom      =   645
         Increment       =   10
         Max             =   250
         Min             =   50
         SyncBuddy       =   -1  'True
         BuddyProperty   =   0
         Enabled         =   -1  'True
      End
   End
   Begin VB.CheckBox chkPerspective 
      Caption         =   "Perspective"
      Height          =   375
      Left            =   360
      TabIndex        =   5
      Top             =   4560
      Width           =   1275
   End
   Begin VB.Frame frmAspect 
      Caption         =   "Aspect x 10"
      Height          =   1230
      Left            =   300
      TabIndex        =   3
      Top             =   1740
      Width           =   1335
      Begin ComCtl2.UpDown UpDown1 
         Height          =   450
         Left            =   1020
         TabIndex        =   6
         Top             =   240
         Width           =   195
         _ExtentX        =   344
         _ExtentY        =   794
         _Version        =   327681
         Value           =   4
         BuddyControl    =   "txtAspect"
         BuddyDispid     =   196613
         OrigLeft        =   960
         OrigTop         =   300
         OrigRight       =   1155
         OrigBottom      =   645
         Max             =   16
         Min             =   4
         SyncBuddy       =   -1  'True
         BuddyProperty   =   0
         Enabled         =   -1  'True
      End
      Begin VB.TextBox txtAspect 
         Height          =   285
         Left            =   255
         TabIndex        =   4
         Text            =   "Text1"
         Top             =   345
         Width           =   675
      End
      Begin VB.Label Label1 
         Caption         =   "10 is a sphere"
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   780
         Width           =   1095
      End
   End
   Begin VB.Timer Timer2 
      Left            =   690
      Top             =   6675
   End
   Begin VB.CommandButton cmdAnimV 
      Caption         =   "Rotate about horizontal"
      Height          =   495
      Left            =   240
      TabIndex        =   2
      Top             =   960
      Width           =   1395
   End
   Begin VB.CommandButton cmdAnimH 
      Caption         =   "Rotate about poles"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   300
      Width           =   1395
   End
   Begin VB.Timer Timer1 
      Left            =   60
      Top             =   6645
   End
   Begin VB.PictureBox picDisplay 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000006&
      BorderStyle     =   0  'None
      Height          =   6030
      Left            =   1905
      ScaleHeight     =   402
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   400
      TabIndex        =   0
      Top             =   315
      Width           =   6000
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'CIRLIPSOID  by Robert Rayment
'Three dimensional spheres and ellipses

Option Base 1
DefInt A-Q
DefSng R-Z

Dim grxhi, gryhi  'Number of grids

Dim svrx(), svry(), svrz() 'Start X,Y,Z values
Dim rx(), ry(), rz()       'Rotated values
Dim xs(), zs()             'picDisplay points
Dim xT, yT                 'Timer points
Dim xangintv, yangintv     'Timer angle intervals
Dim zaspect                'Spheroid aspect ratio
Dim zrad                   'Spheroid radius

Dim CheckPerspective, ye    'ye, perspective depth

Dim pp As POINTAPI         'For MoveToEx bu not used

Dim culgreen&, culcyan&    'Lat & Long colors

Const zpi# = 3.1415927
Const dtr# = zpi# / 180
Const rtd# = 180 / zpi#

Private Sub Form_Load()
Caption = "CIRLIPSOID by Robert Rayment"
'Plotting intervals
grxhi = (1 + 360 / 18): gryhi = (1 + 360 / 18)
ReDim svrx(21, 21), svry(21, 21), svrz(21, 21)
ReDim rx(21, 21), ry(21, 21), rz(21, 21)
ReDim xs(21, 21), zs(21, 21)
   
   Timer1.Interval = 1
   Timer1.Enabled = False
   Timer2.Interval = 1
   Timer2.Enabled = False
   'Timer angular steps
   xangintv = 15: yangintv = 15
   'Starting aspect & perspective depth
   txtAspect.Text = 10
   txtPerspec.Text = 150

culgreen& = QBColor(10) 'Latitude lines
culcyan& = QBColor(11)  'Longitude lines


'Cirlipsoid
zrad = 100
picDisplay.Height = 400
picDisplay.Width = 400

''For exact pic size without perspective
'If za > 1 Then
'   picDisplay.Height = za * 2 * zrad
'Else
'   picDisplay.Height = 2 * zrad
'End If
'picDisplay.Width = 2 * zrad
'If za < 1 Then
'   picDisplay.Width = 2 * zrad
'Else
'   picDisplay.Width = 2 * zrad
'End If
   
'FILL ARRAYS WITH X,Y,Z VERTICES
'USING SPHERICAL COORDINATES
'---------
FillArrays
'---------
End Sub

Private Sub FillArrays()
ye = Val(txtPerspec.Text)
zaspect = Val(txtAspect.Text) / 10
j = 0
For ztheta = 0 To 360 Step 18
   i = 0
   j = j + 1
   zt = ztheta * dtr#
For zphi = 0 To 360 Step 18
   i = i + 1
   zp = zphi * dtr#
   x = zrad * Sin(zt) * Cos(zp)
   y = zrad * Sin(zt) * Sin(zp)
   Z = zaspect * zrad * Cos(zt)
   svrx(i, j) = x
   svry(i, j) = y
   svrz(i, j) = Z
Next zphi
Next ztheta

xT = 0: yT = 0
'------------------------------
picDisplay_MouseMove 1, 0, xT, yY
'------------------------------
End Sub

Private Sub picDisplay_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
'-----------------------------------
CalculateScreenPoints x, y
'-----------------------------------
'Dim pp As POINTAPI Not used but API needs it
'res& = LineTo(Form1.hdc, xx&, yy&)
'res& = MoveToEx(Form1.hdc, xx&, yy&, pp)

picDisplay.Cls 'Simplest & Fast enough
phdc& = picDisplay.hdc  'picDisplay device context

'Draw X-latitude lines
picDisplay.ForeColor = culgreen&
For j = 1 To gryhi
   res& = MoveToEx(phdc&, xs(1, j), zs(1, j), pp)
For i = 1 + 1 To grxhi
   res& = LineTo(phdc&, xs(i, j), zs(i, j))
Next i
Next j

'Draw Y-longitude lines
picDisplay.ForeColor = culcyan&
For i = 1 To grxhi
   res& = MoveToEx(phdc&, xs(i, 1), zs(i, 1), pp)
For j = 1 + 1 To gryhi
   res& = LineTo(phdc&, xs(i, j), zs(i, j))
Next j
Next i

End Sub

Public Sub CalculateScreenPoints(x, y)
'x,y cursor position from MouseDown

'Get angles based on cursor position
xcen = picDisplay.ScaleWidth / 2
ycen = picDisplay.ScaleHeight / 2
zang = (zpi# / 2) * ((x - xcen) / xcen)   'zang about z-axis
xang = -(zpi# / 2) * ((y - ycen) / ycen)  'xang about x-axis

'Apply rotation to original data about z-axis
For j = 1 To gryhi
For i = 1 To grxhi
   rx(i, j) = svrx(i, j) * Cos(zang) + svry(i, j) * Sin(zang)
   ry(i, j) = svry(i, j) * Cos(zang) - svrx(i, j) * Sin(zang)
   rz(i, j) = svrz(i, j)
Next i
Next j

'Apply rotation about x-axis
For j = 1 To gryhi
For i = 1 To grxhi
   ryy = ry(i, j) * Cos(xang) - rz(i, j) * Sin(xang)
   rz(i, j) = ry(i, j) * Sin(xang) + rz(i, j) * Cos(xang)
   ry(i, j) = ryy
Next i
Next j

If CheckPerspective = 1 Then
   
   'Find the intercept at plane y=0 (ie the screen plane) of the
   'line connecting the eye point (xe,ye,ye) with each function
   'point (rx(),ry(),rz()) in turn.
   'The display intercept points will be modified & unscaled
   'rx(i,j) & rz(i,j)

   'EYE POINT  ye settable
   xe = 0: ze = 0

   For j = 1 To gryhi
   For i = 1 To grxhi
      zd = (ye - ry(i, j))
      If zd = 0 Then
         rx(i, j) = rx(i, j)
      Else
         rx(i, j) = -ye * (xe - rx(i, j)) / zd
      End If
      If zd = 0 Then
         rz(i, j) = rz(i, j)
      Else
         rz(i, j) = -ye * (ze - rz(i, j)) / zd
      End If
   Next i
   Next j

End If

'-------  SCALE FACTORS  ----------

scfx = 1
'xoff = zrad   ''For exact pic size without perspective
xoff = picDisplay.Width / 2
xmin = 0

scfz = 1

''For exact pic size without perspective
'If za > 1 Then
'   zoff = zaspect * zrad
'Else
'   zoff = zrad
'End If

zoff = picDisplay.Height / 2
zmin = 0

'-----  GET PLOTTING POINTS  ----------------------

'Get picDisplay points xs(), zs()
For j = 1 To gryhi
For i = 1 To grxhi
   xs(i, j) = scfx * (rx(i, j) - xmin) + xoff
   zs(i, j) = scfz * (rz(i, j) - zmin) + zoff
Next i
Next j
End Sub

Private Sub Timer1_Timer()
'Rotate about poles
xT = xT + xangintv
If xT > 6000 Or xT < -6000 Then xangintv = -xangintv
'yT = yT + yangintv
'If yT > 6000 Or yT < -6000 Then yangintv = -yangintv
'--------------------------------
picDisplay_MouseMove 1, 0, xT, yT
'--------------------------------
End Sub
Private Sub Timer2_Timer()
'Rotate about horizontal
'xT = xT + xangintv
'If xT > 6000 Or xT < -6000 Then xangintv = -xangintv
yT = yT + yangintv
If yT > 6000 Or yT < -6000 Then yangintv = -yangintv
'--------------------------------
picDisplay_MouseMove 1, 0, xT, yT
'--------------------------------
End Sub

Private Sub cmdAnimH_Click()
'Toggle rotation about poles
If Timer1.Enabled = True Then
   Timer1.Enabled = False
Else
   Timer1.Enabled = True
End If
Timer2.Enabled = False
End Sub
Private Sub cmdAnimV_Click()
'Toggle rotation about horizontal
If Timer2.Enabled = True Then
   Timer2.Enabled = False
Else
   Timer2.Enabled = True
End If
Timer1.Enabled = False
End Sub

Private Sub chkPerspective_Click()
CheckPerspective = chkPerspective.Value
End Sub

Private Sub UpDown1_Change()
'Aspect
FillArrays
End Sub

Private Sub UpDown2_Change()
'Perspective depth
FillArrays
End Sub
Private Sub Form_Unload(Cancel As Integer)
   Timer1.Enabled = False
   Timer2.Enabled = False
Unload Me
End
End Sub

